/*
 * ASE1601.asm
 *
 *  Created: 14/01/2016 18.25.13
 *  Author: Roberto Roncella
 *  Compito del 12/01/2016
 *  Nella memoria di un microcontrollore XMEGA della famiglia AVR, a partire 
 *  dall'indirizzo il cui valore  contenuto nel puntatore Z, 
 *  sono contenuti 3 valori senza segno da 1 byte che rappresentano la lunghezza 
 *  dei 3 lati di un triangolo AB, BC e CA.
 *  Realizzare una subroutine che determina se l'angolo ABC  acuto, retto oppure ottuso 
 *  lasciando nel registro R16 rispettivamente i valori (C2) 1, 0, 1.
 *  Nel caso in cui i 3 segmenti specificati non possano costituire un triangolo, 
 *  in R16 va lasciato il valore 2.
 */ 
test: //sezione di test della subroutine
 ldi ZL,low(0x2000)
 ldi ZH,high(0x2000)
 rcall angle_test //predisporre la memoria con il debugger
 rjmp test

angle_test:
 push R0 //salva i registri usati
 push R1
 push R2
 push R3
 push R17
 push R18
 push R20
 push R21
 push R22

 ld R16,Z //a=AB
 ldd R17,Z+1 //b=BC
 ldd R18,Z+2 //c=CA
 mov R20,R16 //replica a
 mov R21,R17 //replica b
 mov R22,R18 //replica c

 add R20,R17 //a+b
 brcs c_ok //sicuramente a+b>c
 cp R18,R20 //dovrebbe essere c<a+b
 brcc ko //non puo` essere un triangolo
c_ok:
 add R21,R18 //b+c
 brcs a_ok //sicuramente b+c>a
 cp R16,R21 //dovrebbe essere a<b+c
 brcc ko //non puo` essere un triangolo
a_ok:
 add R22,R16 //c+a
 brcs b_ok //sicuramente c+a>b
 cp R17,R22 //dovrebbe essere b<c+a
 brcc ko //non puo` essere un triangolo
b_ok:
 mul R16,R16 //a^2 in R1:R0
 movw R3:R2,R1:R0
 mul R17,R17 //b^2 in R1:R0
 add R2,R0
 adc R3,R1 //in R3:R2 ci va a^2+b^2, da confrontare con c^2
 brcs ottuso //se c'e` riporto l'angolo sara` ottuso
 mul R18,R18 //c^2 in R1:R0
 cp R2,R0
 cpc R3,R1
 breq retto //soddisfa teorema di Pitagora
 brcc ottuso //a^2+b^2>c^2
acuto:
 ldi R16,1
 rjmp end_test_angle
retto:
 ldi R16,0
 rjmp end_test_angle
ottuso:
 ldi R16,-1
 rjmp end_test_angle
ko:
 ldi R16,2
 
end_test_angle:
 pop R22 //ripristina i registri usati, tranne R16 che contiene il risultato
 pop R21
 pop R20
 pop R18
 pop R17
 pop R3
 pop R2
 pop R1
 pop R0
 ret

